package com.its.api.its.service.incident;

import com.its.api.its.model.dto.incident.TbIncdOcrrVmsDto;
import com.its.api.its.model.entity.incident.TbIncdOcrrVms;
import com.its.api.its.repository.incident.TbIncdOcrrVmsRepository;
import lombok.RequiredArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.ArrayList;
import java.util.List;
import java.util.NoSuchElementException;
import java.util.Optional;

@Slf4j
@RequiredArgsConstructor
@Service
public class TbIncdOcrrVmsService {

    private final TbIncdOcrrVmsRepository repo;

    // 데이터 1건 조회, 없으면 exception
    private TbIncdOcrrVms requireOne(String id) {
        return this.repo.findById(id)
                .orElseThrow(() -> new NoSuchElementException("데이터가 존재하지 않습니다: " + id));
    }

    // 전체 데이터 조회
    @Transactional(readOnly = true)
    public List<TbIncdOcrrVmsDto> findAll() {
        List<TbIncdOcrrVmsDto> result = new ArrayList<>();
        List<TbIncdOcrrVms> data = this.repo.findAll();
        for (TbIncdOcrrVms entity : data) {
            result.add(entity.toDto());
        }
        return result;
    }

    // 데이터 1건 조회(기존 데이터가 반드시 존재해야 함)
    @Transactional(readOnly = true)
    public TbIncdOcrrVmsDto findById(String id) {
        TbIncdOcrrVms entity = requireOne(id);
        return entity.toDto();
    }

    // 데이터 변경
    @Transactional
    public TbIncdOcrrVmsDto updateById(String id, TbIncdOcrrVmsDto.TbIncdOcrrVmsUpdReq req) {
        TbIncdOcrrVms entity = requireOne(id);
        entity.updateInfo(req);
        this.repo.save(entity);
        return entity.toDto();
    }

    // 데이터 변경 또는 생성-목록(데이터가 존재하면 업데이트 없으면 신규로 생성)
    @Transactional
    public List<TbIncdOcrrVmsDto> mergeInfoList(List<TbIncdOcrrVmsDto.TbIncdOcrrVmsUpdReq> reqList) {
        List<TbIncdOcrrVmsDto> result = new ArrayList<>();
        for (TbIncdOcrrVmsDto.TbIncdOcrrVmsUpdReq req : reqList) {
            TbIncdOcrrVms obj = req.toEntity();
            this.repo.save(obj);
            result.add(obj.toDto());
        }
        return result;
    }

    // 데이터 변경 또는 생성-개별(데이터가 존재하면 업데이트 없으면 신규로 생성)
    @Transactional
    public TbIncdOcrrVmsDto mergeInfo(TbIncdOcrrVmsDto.TbIncdOcrrVmsUpdReq req) {
        TbIncdOcrrVms obj = req.toEntity();
        /*if (obj.getVmsDsplYn().equals("N")) {
            // VMS 표출 하지 않을 경우 기존에 데이터가 존재하는 경우에만 데이터 저장
            try {
                TbIncdOcrrVms entity = requireOne(obj.getIncdOcrrId());
                log.info("{}", entity);
            }
            catch (Exception e) {
                // 존재하지 않는 경우 처리할 필요 없음.
                return obj.toDto();
            }
        }*/
        // 데이터 저장
        this.repo.save(obj);
        return obj.toDto();
    }

    // 정보 삭제-개별, 데이터 존재하지 않으면 Exception
    @Transactional
    public TbIncdOcrrVmsDto deleteById(String id) {
        TbIncdOcrrVms entity = requireOne(id);
        this.repo.deleteById(id);
        return entity.toDto();
    }

    // 정보 삭제-목록, 존재하는 데이터 만 삭제
    @Transactional
    public List<TbIncdOcrrVmsDto> deleteByIds(List<String> ids) {
        List<TbIncdOcrrVmsDto> result = new ArrayList<>();
        for (String id : ids) {
            Optional<TbIncdOcrrVms> obj = this.repo.findById(id);
            if (obj.isPresent()) {
                this.repo.deleteById(id);
                result.add(obj.get().toDto());
            }
        }
        return result;
    }

}
